package test.core

import lib.core.analysis.{ConflictGenerator, CriticalPair}
import lib.core.common.{Derivation, E, Function, Graph, Morphism, Rule, Span, V}
import org.scalatest.flatspec._
import org.scalatest.matchers.must.Matchers

class ConflictReasonGeneratorSpec extends AnyFlatSpec with Matchers {

  it should "generate conflict reason 1" in {
    val pair: CriticalPair[Unit, Unit] = CriticalPair(Graph(Set(V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(2),()))),Function(Set())),Derivation(Rule("r1",Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set()))),Morphism(Function(Set((V(1),V(2)))),Function(Set()))),Derivation(Rule("r2",Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),Graph(Set(),Set(),Function(Set()),Function(Set()),Function(Set()),Function(Set())),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set()))),Morphism(Function(Set((V(1),V(2)))),Function(Set()))))

    val expected: Option[Span[Unit, Unit]] = Some(Span(Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),(Morphism(Function(Set((V(1),V(1)))),Function(Set())),Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set()))),(Morphism(Function(Set((V(1),V(1)))),Function(Set())),Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())))))

    assert(ConflictGenerator.generateConflictReason(pair) == expected)
  }

  it should "generate conflict reason 2" in {
    val pair: CriticalPair[Unit, Unit] = CriticalPair(Graph(Set(V(2)),Set(E(3)),Function(Set((E(3),V(2)))),Function(Set((E(3),V(2)))),Function(Set((V(2),()))),Function(Set((E(3),())))),Derivation(Rule("r1",Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set()))),Morphism(Function(Set((V(1),V(2)))),Function(Set()))),Derivation(Rule("r3",Graph(Set(V(1)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(1)))),Function(Set((V(1),()))),Function(Set((E(1),())))),Graph(Set(),Set(),Function(Set()),Function(Set()),Function(Set()),Function(Set())),Graph(Set(),Set(),Function(Set()),Function(Set()),Function(Set()),Function(Set()))),Morphism(Function(Set((V(1),V(2)))),Function(Set((E(1),E(3)))))))

    val expected: Option[Span[Unit, Unit]] = Some(Span(Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set())),(Morphism(Function(Set((V(1),V(1)))),Function(Set())),Graph(Set(V(1)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()))),Function(Set()))),(Morphism(Function(Set((V(1),V(1)))),Function(Set())),Graph(Set(V(1)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(1)))),Function(Set((V(1),()))),Function(Set((E(1),())))))))

    assert(ConflictGenerator.generateConflictReason(pair) == expected)
  }

  it should "generate conflict reason 3" in {
    val pair: CriticalPair[Unit, Unit] = CriticalPair(Graph(Set(V(2), V(4), V(6)),Set(E(2), E(4), E(3)),Function(Set((E(2),V(2)), (E(4),V(6)), (E(3),V(4)))),Function(Set((E(2),V(6)), (E(4),V(4)), (E(3),V(2)))),Function(Set((V(2),()), (V(4),()), (V(6),()))),Function(Set((E(2),()), (E(4),()), (E(3),())))),Derivation(Rule("r1",Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(2)))),Function(Set((V(1),()), (V(2),()))),Function(Set((E(1),()))))),Morphism(Function(Set((V(1),V(2)), (V(2),V(4)), (V(3),V(6)))),Function(Set((E(1),E(2)), (E(2),E(4)))))),Derivation(Rule("r1",Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(2)))),Function(Set((V(1),()), (V(2),()))),Function(Set((E(1),()))))),Morphism(Function(Set((V(3),V(2)), (V(1),V(4)), (V(2),V(6)))),Function(Set((E(2),E(2)), (E(1),E(3)))))))

    val expected: Option[Span[Unit, Unit]] = Some(Span(Graph(Set(V(6), V(2), V(4)),Set(E(2)),Function(Set((E(2),V(2)))),Function(Set((E(2),V(6)))),Function(Set((V(6),()), (V(2),()), (V(4),()))),Function(Set((E(2),())))),(Morphism(Function(Set((V(6),V(3)), (V(2),V(1)), (V(4),V(2)))),Function(Set((E(2),E(1))))),Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),()))))),(Morphism(Function(Set((V(6),V(2)), (V(2),V(3)), (V(4),V(1)))),Function(Set((E(2),E(2))))),Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))))))

    assert(ConflictGenerator.generateConflictReason(pair) == expected)
  }

  it should "generate conflict reason 4" in {
    val pair: CriticalPair[Unit, Unit] = CriticalPair(Graph(Set(V(2), V(4), V(6), V(5)),Set(E(2), E(4), E(5)),Function(Set((E(2),V(2)), (E(4),V(6)), (E(5),V(4)))),Function(Set((E(2),V(6)), (E(4),V(4)), (E(5),V(5)))),Function(Set((V(2),()), (V(4),()), (V(6),()), (V(5),()))),Function(Set((E(2),()), (E(4),()), (E(5),())))),Derivation(Rule("r1",Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(2)))),Function(Set((V(1),()), (V(2),()))),Function(Set((E(1),()))))),Morphism(Function(Set((V(1),V(2)), (V(2),V(4)), (V(3),V(6)))),Function(Set((E(1),E(2)), (E(2),E(4)))))),Derivation(Rule("r1",Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))),Graph(Set(V(1), V(2)),Set(),Function(Set()),Function(Set()),Function(Set((V(1),()), (V(2),()))),Function(Set())),Graph(Set(V(1), V(2)),Set(E(1)),Function(Set((E(1),V(1)))),Function(Set((E(1),V(2)))),Function(Set((V(1),()), (V(2),()))),Function(Set((E(1),()))))),Morphism(Function(Set((V(3),V(4)), (V(1),V(6)), (V(2),V(5)))),Function(Set((E(1),E(4)), (E(2),E(5)))))))

    val expected: Option[Span[Unit, Unit]] = Some(Span(Graph(Set(V(6), V(4)),Set(E(4)),Function(Set((E(4),V(6)))),Function(Set((E(4),V(4)))),Function(Set((V(6),()), (V(4),()))),Function(Set((E(4),())))),(Morphism(Function(Set((V(6),V(3)), (V(4),V(2)))),Function(Set((E(4),E(2))))),Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),()))))),(Morphism(Function(Set((V(6),V(1)), (V(4),V(3)))),Function(Set((E(4),E(1))))),Graph(Set(V(1), V(2), V(3)),Set(E(1), E(2)),Function(Set((E(1),V(1)), (E(2),V(3)))),Function(Set((E(1),V(3)), (E(2),V(2)))),Function(Set((V(1),()), (V(2),()), (V(3),()))),Function(Set((E(1),()), (E(2),())))))))

    assert(ConflictGenerator.generateConflictReason(pair) == expected)
  }
}
